#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


/*
tty

http://pubs.opengroup.org/onlinepubs/7908799/xsh/open.html
http://pubs.opengroup.org/onlinepubs/7908799/xsh/read.html
http://pubs.opengroup.org/onlinepubs/7908799/xsh/write.html

http://stackoverflow.com/questions/2899180/how-can-i-use-com-and-usb-ports-within-cygwin
ls -lah /dev

stty -F /dev/pty0 9600
http://raspberrypi.stackexchange.com/questions/7730/how-to-configure-serial-port-settings-of-dev-ttyama0

http://man7.org/linux/man-pages/man7/pty.7.html
    fp = open("/dev/ttyAMA0", O_RDONLY | O_NOCTTY );

*/

#pragma 1

typedef struct
{
    char dev_key[3];
    char dev_name[10];
    char dev_value[4];
} DEV_STR ;

DEV_STR sBuf ;

/*
/dev/pty1  ڱ ܼȭ鿡  (ٸ α׷ read  )
/dev/pty0 ٸ ܼ ȭ鿡    (ٸ α׷ read  )


-------------------------------------------------------------------------------------------------
/dev/ttyS1  fd   ޽ µ. ȵǴ°Ŵ.
˰. ׽Ʈϴ ComPort Ϳ COM2 Ʈ ̹  ־. ȵȰſ. _;; ...
Լ  ޽ ׻ Ȯغ Ѵ.
-------------------------------------------------------------------------------------------------

*/

int main(int argc, char** argv) 
{
    // ø   Device Open
    int fp;

    ssize_t res;
    
//    fp = open("/dev/ttyS1", O_RDWR | O_NOCTTY | O_RSYNC | O_SYNC);   //| O_RSYNC | O_SYNC    .
    fp = open("/dev/ttyS1", O_WRONLY | O_NOCTTY);

    printf("argc [%d]\n", argc);

//    fp = atoi(argv[1]);
    printf("fp [%d]\n", fp);
//    printf("argv[0] [%s]\n", argv[0]);
//    printf("argv[1] [%s]\n", argv[1]);
//    printf("argv[2] [%s]\n", argv[2]);

    strcpy(sBuf.dev_key, "123");
    strcpy(sBuf.dev_name, "4567890123");
    strcpy(sBuf.dev_value, "4567");

    int len = sizeof(DEV_STR);
    printf("sizeof(DEV_STR) : [%d]\n", len);

//    res = write( fp, &sBuf, len) ;
//    printf("write len : [%d]\n", res);


    res = write( fp, sBuf.dev_key, 3) ;
    printf("write len : [%d]\n", res);

    res = write( fp, sBuf.dev_name, 10) ;
    printf("write len : [%d]\n", res);

    res = write( fp, sBuf.dev_value, 4) ;
    printf("write len : [%d]\n", res);

/*
read() Ѵ⸦ ֱ ؼ  ڵ ε. ƹ  .
    res = write( fp, '\0', 1) ;
*/  

    sleep(1);

    close(fp);

    return 0;
}




